<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>CS 1653 Project P4 Writeup</title>
  <style>
/* BEGIN CHANGES HERE */

/* In this section, you may add CSS styling if desired */
header {
    text-align: center;
}

table, th, td {
    border: 1px solid black;
}

body {
    margin: 40px auto;
    max-width: 62%;
    line-height: 1.6;
    font-size: 18px;
    color: #444;
    padding: 0 10px;
}

/* END CHANGES HERE */
  </style>
  <body>
    <header>
      <h1>CS 1653 Project P4 Writeup</h1>
      <h2>
<!-- BEGIN CHANGES HERE -->

      <p>Christopher Constantino</p>
      <p>Jordon Rapoport</p>
      <p>Michael Stoltz</p>

<!-- END CHANGES HERE -->
      </h2>
    </header>
    <section id="overview">
      <h2>Overview</h2>
<!-- BEGIN CHANGES HERE -->

<p>To address the threats added in this phase, we will employ a panoply of
techinques, including MACs, sequence numbers, key chaining and distribution,
and an extension to our token signing technique.</p>

<p>The adjustment to our protocols will require interleaving the (previously
separate) communications between the client and either type of server. Because
the various adjustments will require combining protocols from previous phases
in new ways, a complete diagram depicting the combined protocols for connecting
to a file server is shown below. The less obvious parts of the notation have
explanatory hovertext.</p>

<figure>
<dl>
  <dd>Initial state:</dd>
  <dt>
    GS has the user's salt, SRP verifier,
    a key pair (K<sub>G</sub>, K<sub>G</sub><sup>-1</sup>),
    a list of users and groups, and a list of key sequences for each group.
  </dt>
  <dt>
    FS has a key pair (K<sub>F</sub>, K<sub>F</sub><sup>-1</sup>).
  </dt>
  <dt>
    The user U needs only to know his username, password, and the public key
    fingerprints of the servers he trusts.
  </dt>
    <dd>Start of SRP exchange.</dd>
  <dt>U &#8594; GS: <var>username</var></dt>
  <dt>U &#8592; GS: <var>salt</var></dt>
  <dt>U &#8594; GS: <var>A</var></dt>
  <dt>U &#8592; GS: <var>B</var></dt>
  <dt>
    U &#8594; GS:
    <span title="Client proof of identity"><var>M<sub>1</sub></var></span>
  </dt>
  <dt>
    U &#8592; GS:
    <span title="Server proof of identity"><var>M<sub>2</sub></var></span>,
    <span title="IV for cipher"><var>IV<sub>G</var></sub></span>,
    {
      <span title="Integrity key for MACs">
        <var>K<sub>i<sub>1</sub></sub></var>
      </span>
    }
    <span title="Symmetric key for U/GS from SRP exchange">
      <var>K<sub>UG</sub></var>
    </span>
  </dt>
    <dd>
      End of SRP exchange; U now has secure connection to GS.
    </dd>
    <dd>
      If the user only wants to perform actions with the group server, the
      protocol ends here.
    </dd>
  <dt>
    U &#8594; GS:
    { <span title="Request for token"><code>"GET"</code></span> }<var>K<sub>UG</sub></var>
  </dt>
    <dd>U requests a token for use with GS.</dd>
  <dt>
    U &#8592; GS:
    { <var>Token<sub>G</sub></var> }<var>K<sub>UG</sub></var>
  </dt>
    <dd>
      The GS retrieves its own public key fingerprint and uses it to compute
      the hash for the token; it then signs the hash, preventing the token from
      being used with a server other than itself.
    </dd>
  <dt>
    U &#8594; FS:
      (Open a connection.)
  <dt>
    U &#8592; FS:
    <span title="File server's public key"><var>K<sub>F</sub></var></span>,
    <span title="IV for cipher, doubles as a nonce"><var>IV<sub>F</sub></var></span>
  </dt>
    <dd>If U trusts K<sub>F</sub>:</dd>
  <dt>
    U &#8594; FS:
    {
      <span title="Symmetric key for encrypting communications">
        <var>K<sub>UF</sub></var>
      </span>,
      <span title="Same IV as before, used to ensure the key was agreed upon">
        <var>IV<sub>F</sub></var>,
      </span>
      <span title="Integrity key for U/FS">
        <var>K<sub>i<sub>2</sub></sub></var>
      </span>
    }K<sub>F</sub>
  </dt>
    <dd>U now has secure connection to FS.</dd>
  <dt>
    U &#8594; GS:
    {
      <span title="Request for second token"><code>"GET"</code></span>,
      <span title="SHA-256 fingerprint of FS's key">
        H(<var>K<sub>F</sub></var>)
      </span>
    }K<sub>UG</sub>
  </dt>
  <dt>
    U &#8592; GS:
    {
      <span title="Token for file server">
        <var>Token<sub>F</sub></var>
      <span>
    }<var>K<sub>UG</sub></var>
  </dt>
    <dd>User gets a token for FS.</dd>
    <dd>Requests are then performed like:</dd>
  <dt>
    U &#8594; GS/FS (respectively):
    {
      <var>action identifier</var>,
      <var>Token<sub>G/F</sub></var>,
      <var>sequence number</var>,
      <var>additional contents</var>
    }K<sub>G/F</sub>, <br>
    &nbsp;&nbsp;&nbsp;&nbsp;MAC(K<sub>i<sub>1/2</sub></sub>, <var>first part of message</var>)
  </dt>
</dl>
</figure>


<!-- END CHANGES HERE -->
    </section>
    <section id="threat5">
      <h2>Threat T5: Message Reorder, Replay, or Modification</h2>
<!-- BEGIN CHANGES HERE -->

<p>After the user connects to a group or file server, encrypted messages will be sent between them.  Although an adversary cannot get any of the information from these messages, that does not mean they cannot still cause harm.  An adversary could reorder messages being sent between the user and the server.  For example the user could ask to download a file and then delete it, but the adversary could make the file be deleted first, making it unavailable to the user.  The adversary could also save all of the messages sent between the user and the server and replay them later, gaining access to the server.  Additionally the adversary could manipulate messages, although they seem like nonsense to them, changing them randomly would make it impossible for the user to accomplish any of their tasks.</p>

<p>In order to handle the replaying, reordering, and manipulation of messages, we will use a few different mechanisms.  Luckily our protocols used in the last phase of the project already protect against replay attacks by using nonces when establishing the connection between servers and the user.  In order to protect against reordering, we will use message counters.  Every time a message is sent between a server and the user, a count will be send as part of it.  When the message is received, the count in it will be checked by the receiver to make sure it is one more than the count received by the previous message.  To solve the issue of manipulation, a MAC (changing algorithms if necessarily will not be difficult, but we will initially use SipHash-2-4 unless some problem arises with it) will now also be sent along with all messages that verifies the message had not been tampered with.</p>

<p>The mechanisms we use for the parts of this threat will solve the issues they cause.  The nonces used in authentication from the previous phase of the project help enforce freshness; since a new nonce is generated on each attempted connection to the servers, the authentication messages cannot be reused to gain access to the server on a new connection.  Using the counters sent along with messages and checking against the current count will allow us to detect message reordering and respond appropriately.  MACs are a very good way of ensuring the integrity of messages, and both the client and servers will verify the MAC accompanying each encrypted message, similarly to how we currently verify the integrity of tokens.</p>

<!-- END CHANGES HERE -->
    </section>
    <section id="threat6">
      <h2>Threat T6: File Leakage</h2>
<!-- BEGIN CHANGES HERE -->

<p>This threat effectively reduces to us no longer trusting either file servers
or clients. We approach this threat with the assumption that a file server is
at risk of releasing any file contents that pass through its memory or disk
storage. Effectively, this means we cannot entrust the file server with a
plaintext version of a file, not even to immediately encrypt it, throw away the
plaintext form, and store the encrypted form. We also assume that it is an
unreasonable burden to place on the group server if we were to require it to
perform the encryption or decryption of files.</p>

<p>As a result, our scheme will place the task of encrypting and decrypting on the
client. The scheme works as follows:</p>

<p>For each group on the group server, the group server remembers a sequence
of keys. Each group also has associated with it a removal count <var>R</var>,
which is some non-negative integer. Whenever a user is removed from a group,
that group's removal count is incremented. The key for a group at any given
time is the <var>R</var><sup>th</sup> key in the sequence. The keys we will
use specifically are 128- or 256-bit AES keys, depending on the initial
configuration.</p>

<p>To encrypt a file before transmitting it to a file server, the client will
request the <var>R</var><sup>th</sup> key from the group server to perform
the encryption with. The user will generate a random IV for the AES cipher
and encrypt the file using that key and IV in OFB mode. The IV and value of
<var>R</var> will be transmitted to the file server to be stored along with the
encrypted file. Note that this means files encrypted with the key from some
removal count <var>t</var> &lt; <var>R</var> will remain stored on file servers
until some time that they are updated by a current member of the group. As a
result, when downloading a file encrypted with an old key, users may request
the <var>t</var><sup>th</sup> key for a file (provided they have access to that
file) from the group server, which is able to retrieve it.</p>

<p>This scheme offers both forward and backward secrecy with respect to group
keys, provided that the conditions under which the group server generated the
keys for some group remain unpredictable.</p>

<p>The flaw with this scheme is that, because files are re-encrypted
lazily, if (a) there is some disgruntled user who was removed from his
group as the <var>R</var><sup>th</sup> removal, and (b) there is some
rogue file server which has access to files which were encrypted with the
<var>t</var><sup>th</sup> key for some <var>t</var> &lt; <var>R</var>, then
that user, provided that he stored some keys prior to his removal, is able
to collude with that file server to decrypt those files. However, we do not
consider this a serious flaw. Even without storing old keys, a user is capable
of downloading all files he has access to at any time. There is no way to
retroactively un-download a file from some uncooperative user's computer when
revoking his group membership, so the issue of users hoarding old keys is of no
consequence.</p>

<p>We also considered a similar scheme in which the group server stores a seed
for each group, and the key to be used after <var>R</var> removals would be
the <var>R</var><sup>th</sup> key-sized output of a CSPRNG seeded with that
group's seed. This approach has the advantage of not storing old keys which
eventually end up never being used again, but also creates a denial of service
vulnerability in which an attacker can repeatedly request old keys, each of
which is linear in <var>R</var> to compute.</p>

<!-- END CHANGES HERE -->
    </section>
    <section id="threat7">
      <h2>Threat T7: Token Theft</h2>
<!-- BEGIN CHANGES HERE -->

<p>The user must transmit the token obtained from the group server to a file
server in order to perform any actions. The file server must also be able to
read the contents of the token. This leads to a potential threat in which a
file server, through accident or malice, allows a user's token to be obtained
by an untrusted third party. Our goal is to minimize the scope of the damage in
this scenario. One way to do so is to make tokens specific to a given file
server. If we accomplish this, then the mishandling of a token by a single file
server does not compromise any other parts of the system.</p>

<p>To protect against this threat, we propose the following mechanism.</p>

<h3>Making tokens unique to servers</h3>

<p>First, some background. In our current implementation, connection to a file
server requires the following steps:</p>

<ol>
<li>The user initiates a secure connection with the group server and requests
a token.</li>
<li>The group server creates a token for that particular user and computes the
hash of that token as follows:
(A) Obtain a byte representation of <var>issuer</var>, <var>subject</var>, and
<var>groups</var> by encoding them in UTF-8.
(B) Join the strings together with the delimiter 0xF4F4F4F4 (an invalid
byte sequence in UTF-8), with <var>issuer</var> first, <var>subject</var>
second, and each string in <var>groups</var>, sorted lexicographically as
byte strings, with duplicates removed.
(C) Take the SHA-256 hash of the resulting string of bytes.</li>
<li>The group server signs that hash with its private key and returns the token
to the user.</li>
<li>The user initiates a secure connection with the file server and sends that
token along with any requests.</li>
</ol>

<p>Step 4 requires the user to verify that he trusts a particular file server's
public key by prompting him with the SHA-256 fingerprint of that key. Our
proposed change is to add this fingerprint as a separate field to the user
token. Then, when we reach step 4, the client will make use of the session key
it shares with the group server (generated in step 1) to request a new token
which is specific to the file server being connected to. At the end of step 1,
the user sends a message like so:</p>

<figure><code>
{ "GET" }<span title="The key shared between the user and group server">K<sub>UG</sub></span>
</code></figure>

<p>We will change it to include the hostname as well:</p>

<figure><code>
{ "GET",
<span title="SHA-256 hash">H</span>(
<span title="The file server's public key">K<sub>FS</sub></span>
) }K<sub>UG</sub>
</code></figure>

<p>Now that the group server has the fingerprint, it will add those bytes
to the token after the subject and issuer but before the groups. The
canonicalization algorithm above will be modified to include the fingerprint
with the rest of the (byte-encoded) strings in step (B). The group server and
user then perform step 3 and 4 as usual. Now, when the user submits the token
to the file server to request an action, that file server will verify the
token by generating a hash of what it thinks is its public key, and compare
the resulting token hash with the hash signed by the group server. If the file
server is legitimate, it will refuse to perform any actions unless that token
was intended for use with it.</p>

<p>Similarly, the group server will make use of the new field in the token to
put its own key fingerprint. This will ensure in the same way as above that
the token which the user uses when requesting actions from the group server is
unique to that group server. There is only one group server in our system, but
this change is necessary to prevent a token intended for use with the group
server being stolen and repurposed for use with some other server.</p>

<p>This proposed mechanism is secure provided that the mechanisms from phase
3 are also secure. It suffers from one main weakness. It requires the client
to hold two tokens, one for the group server and one for a file server, which
provides attackers twice the opportunity to get ahold of a token.</p>

<!-- END CHANGES HERE -->
    </section>
    <section id="discussion">
      <h2>Discussion</h2>
<!-- BEGIN CHANGES HERE -->

<p>We had remarkable success when taking a one-at-a-time approach to designing
protections against the new threats. Each part of the design requires only
marginal changes to the existing implementation, and will likely result in
little conflict even if implemented in parallel. We considered a few additional
protections, such as imposing time limits on the validity of tokens, but
decided to save that for a later phase of the project if possible.</p>

<p>It was fairly easy to adjust our design so as to preserve its security
against the threats from the previous phase. We took active attacks into
account when choosing SRP and designing our other authentication protocol,
so minimal adjustments were required there. Our new method of making tokens
unique to specific servers only needs a tiny adjustment to a small part of
the overall mechanism and does not affect the security of the approach. The
threat of unauthorized file servers is made even lesser, because even if the
authentication assumptions are violated, only file metadata are uploaded in a
way that file servers can decrypt; the file contents will be indecipherable.
With respect to the risk of leaking information by passive monitoring, the
only new thing that is ever transmitted in plaintext form is the MAC that
accompanies each encrypted message. Given that we use a cryptographically
strong pseudorandom function, these MACs leak no useful information.</p>

<!-- END CHANGES HERE -->
    </section>
  </body>
</html>

